'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _scuttlebutt = require('scuttlebutt');

var _scuttlebutt2 = _interopRequireDefault(_scuttlebutt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dispatcher = function (_Scuttlebutt) {
  _inherits(Dispatcher, _Scuttlebutt);

  function Dispatcher() {
    _classCallCheck(this, Dispatcher);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Dispatcher).call(this));

    var store = _this._store = [];
    _this._hash = {};
    return _this;
  }

  // Apply update (action) to our store


  _createClass(Dispatcher, [{
    key: 'applyUpdate',
    value: function applyUpdate(_ref) {
      var _ref2 = _slicedToArray(_ref, 3);

      var action = _ref2[0];
      var timestamp = _ref2[1];
      var source = _ref2[2];

      // we simply log and emit all actions, and ensure their order as we see them.
      // [[id,payload],timestamp,source_id]
      this._store.push([action, timestamp, source]);

      // ensure order
      var newerTimestamp = Infinity;
      for (var i = this._store.length - 1; i >= 0; i--) {
        var _store$i = _slicedToArray(this._store[i], 3);

        var thisAction = _store$i[0];
        var thisTimestamp = _store$i[1];
        var thisSource = _store$i[2];


        if (thisTimestamp > newerTimestamp) {
          // older timestamp greater than recent max
          console.warn('out of order!!!', newerTimestamp, thisAction, thisTimestamp, thisSource);
        }
      }

      this.emit('action', action, timestamp, source);

      // applied successfully
      return true;
    }
  }, {
    key: 'history',
    value: function history(sources) {
      return this._store.filter(function (update) {
        return (0, _scuttlebutt.filter)(update, sources);
      });
    }
  }, {
    key: 'localUpdate',
    value: function localUpdate(action) {
      // console.log('result', this._filterUpdate(action))
      // super.localUpdate(this._filterUpdate(action))
      _get(Object.getPrototypeOf(Dispatcher.prototype), 'localUpdate', this).call(this, action);
    }
  }, {
    key: '_filterUpdate',
    value: function _filterUpdate(value) {
      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') return value;

      if (value && value.constructor && /(^Synthetic|Event$)/.test(value.constructor.name)) return null;

      var result = {};
      for (var prop in value) {
        result[prop] = this._filterUpdate(value[prop]);
      }
      return result;
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._store;
    }

    // TODO: emit 'replay'/'rewind' event when old actions come in

    // TODO: garbage collect / compress actions into a single diff

  }]);

  return Dispatcher;
}(_scuttlebutt2.default);

exports.default = Dispatcher;